//=============================================================================
//    *.dat  L-Graph I 
// 															  *.txt (ASCII)
//=============================================================================
#include <windows.h>
#include <stdio.h>
#include <conio.h>

//    
void AbortProgram(char *ErrorString, bool AbortionFlag = true);
//      
DWORD WINAPI ServiceConvertThread(PVOID /*Context*/);
//     
void ShowThreadErrorMessage(void);


//    
#define	NORMAL_CODE_STRING				"2571090,1618190" 	// 20 
#define	ADVANCED_CODE_STRING				"2571090,1618190 A" 	// 20 

const WORD		MAX_ADC_CHANNEL_QUANTITY   = 0x20; 			//  32  
//const DWORD		MAX_DATA_BUFFER_SIZE			= 128*1024;		//    
const DWORD		MAX_CHAR_BUFFER_SIZE			= 2*1024*1024;	//    

//
typedef 	unsigned __int64					QWORD;

#pragma pack(1)
//     
struct COMMON_PARS
{
   char CodeString[20];			// 20  -  
   char DeviceName[17];			// 17  -  
};

//        
struct VARIATIONAL_PARS_0
{
   char TimeString[26];			// 26  -      
   WORD ChannelsMax;          // 2  -      
   WORD RealChannelsQuantity; // 2  -   () 
   DWORD  RealKadrsQuantity;    // 4  -      'int' (< 2.147.483.648)
   DWORD  RealSamplesQuantity;  // 4  -      'int' (< 2.147.483.648)
   double TotalTime;          // 8  -    c   'DOUBLE'
   float AdcRate;             // 4  -       'FLOAT'
   float InterkadrDelay;      // 4  -       'FLOAT'
   float ChannelRate;         // 4  -           'FLOAT'
   bool  ActiveAdcChannelArray[32];  	// 4*32 - ,  
						                  	//     ,  
							                  //  ,    
   BYTE  AdcChannelArray[32];	// 1*32 - ,  
										//        
   BYTE  AdcGainArray[32];    // 1*32 - ,   
                              //     (0,1,2  3)
   BYTE  IsSignalArray[32];   // 1*32 - ,   
				                  //     ,  
            				      //  ,       
};

//        
//      
struct VARIATIONAL_PARS_1
{
   char TimeString[26];			// 26  -      
   WORD ChannelsMax;          // 2  -      
   WORD RealChannelsQuantity; // 2  -   () 
   QWORD  RealKadrsQuantity;    // 8  -      'unsigned __int64' (< 18.446.744.073.709.551.614)
   QWORD  RealSamplesQuantity;  // 8  -      'unsigned __int64' (< 18.446.744.073.709.551.614)
   long double TotalTime;       // 10  -    c   'LONG DOUBLE'
   double AdcRate;             // 8  -       'DOUBLE'
   double InterkadrDelay;      // 8  -       'DOUBLE'
   double ChannelRate;         // 8  -           'FLOAT'
   BOOL  ActiveAdcChannelArray[MAX_ADC_CHANNEL_QUANTITY];  	// 4*32 - ,  
						                  	//     ,  
							                  //  ,    
   BYTE  AdcChannelArray[MAX_ADC_CHANNEL_QUANTITY];	// 1*32 - ,  
										//        
   BYTE  AdcGainArray[MAX_ADC_CHANNEL_QUANTITY];		// 1*32 - ,   
                              //     (0,1,2  3)
   BYTE  IsSignalArray[MAX_ADC_CHANNEL_QUANTITY];		// 1*32 - ,   
				                  //     ,  
            				      //  ,       
};

//     
union VARIATIONAL_PARS
{
	VARIATIONAL_PARS_0 Normal;
	VARIATIONAL_PARS_1 Advanced;
};

//    
struct PARS_OF_WRITE_FILE
{
	COMMON_PARS CommonPars;					//     
	VARIATIONAL_PARS VariationalPars;	//     
};
#pragma pack()

//  
char Code[20], DeviceName[17];
QWORD i;
QWORD ChannelsQuantity, TotalSamplesQuantity, TotalKadrsQuantity;
QWORD BlockSamplesQuantity, BlockKadrsQuantity;
QWORD CurSamplesQuantity, OldCurSamplesQuantity;

//  
SHORT *DataBuffer;
//  
BYTE *CharBuffer;

//   
PARS_OF_WRITE_FILE ParsFile;
FILE *fpSourceFile, *fpTargetFile, *fpParsFile;

//      
bool IsConvertThreadComplete;
//      
WORD ConvertThreadErrorNumber;

//    
HANDLE hConvertThread;
DWORD ConvertTid;

//  
char Stroka[85];

//------------------------------------------------------------------------
//  
//------------------------------------------------------------------------
int main(int n_p, char **str_p)
{
	char SourceFileName[20];
	char ParsFileName[20];
	char TargetFileName[20];
	char *endptr;

	//      
	IsConvertThreadComplete = false;
	//          
	DataBuffer = NULL;
	//      
	hConvertThread = NULL;
	//     :(
	fpSourceFile = fpTargetFile = fpParsFile = NULL;
	//      
	ConvertThreadErrorNumber = 0x0;


	//   
	clrscr();

	//   
	printf("\n\n File converter from 'bin' format to 'text' for L-Graph I data files.\n");
	printf(" Copyright (c) 2008 L-Card Ltd.\n");
	printf(" Usage: convert.exe  filename[.dat]\n");

	if(n_p != 2) AbortProgram("\n	------- ERROR: Data Filename is required!!!\n\n");

	//   
	strcpy(SourceFileName, str_p[n_p-1]);
	strcpy(ParsFileName, str_p[n_p-1]);
	strcpy(TargetFileName, str_p[n_p-1]);

	//    
	if(!(endptr=strchr(SourceFileName, '.'))) strcat(SourceFileName, ".dat");
	else { strlwr(endptr); if(strcmp(endptr, ".dat")) AbortProgram("\n File extention must be '.dat'!"); }

	//    
	if(!(endptr=strchr(ParsFileName,'.'))) strcat(ParsFileName, ".par");
	else { *endptr=0; strcat(ParsFileName, ".par"); }

	//    
	if(!(endptr=strchr(TargetFileName,'.'))) strcat(TargetFileName, ".txt");
	else { *endptr=0; strcat(TargetFileName, ".txt"); }

	fpSourceFile = fopen(SourceFileName, "rb");
	if(!fpSourceFile)	{ sprintf(Stroka,"\n  Can't find %s file!\n", SourceFileName); AbortProgram(Stroka); }

	fpParsFile = fopen(ParsFileName, "rb");
	if(!fpParsFile) { sprintf(Stroka, "\n  Can't find %s file!\n", ParsFileName); AbortProgram(Stroka); }

	fpTargetFile=fopen(TargetFileName, "wt");
	if(!fpTargetFile)	{ sprintf(Stroka, "\n  Can't open %s file!\n", TargetFileName); AbortProgram(Stroka); }

	//    
	if(sizeof(COMMON_PARS) == fread(&ParsFile.CommonPars, 0x1, sizeof(COMMON_PARS), fpParsFile))
	{
		//     
		if(!strcmp(ParsFile.CommonPars.CodeString, NORMAL_CODE_STRING))
		{
			if(sizeof(VARIATIONAL_PARS_0) != fread(&ParsFile.VariationalPars, 0x1, sizeof(VARIATIONAL_PARS_0), fpParsFile)) AbortProgram("Size error in variational_0 part of parsfile structure!");
		}
		else if(!strcmp(ParsFile.CommonPars.CodeString, ADVANCED_CODE_STRING))
		{
			if(sizeof(VARIATIONAL_PARS_1) != fread(&ParsFile.VariationalPars, 0x1, sizeof(VARIATIONAL_PARS_1), fpParsFile)) AbortProgram("Size error in variational_1 part of parsfile structure!");
		}
		// !!! -   :(((
		else AbortProgram("  Code string error in common part of parsfile structure!");

		//   
		if(strcmp(ParsFile.CommonPars.DeviceName, "L761")		&&
			strcmp(ParsFile.CommonPars.DeviceName, "L780")		&&
			strcmp(ParsFile.CommonPars.DeviceName, "L783")		&&
			strcmp(ParsFile.CommonPars.DeviceName, "L791")		&&
			strcmp(ParsFile.CommonPars.DeviceName, "L1450")		&&
			strcmp(ParsFile.CommonPars.DeviceName, "E-154")		&&
			strcmp(ParsFile.CommonPars.DeviceName, "E14-140")	&&
			strcmp(ParsFile.CommonPars.DeviceName, "E14-440"))
				AbortProgram("  Device name error in common part of parsfile structure!");
	}
	// !!!   :(((
	else AbortProgram("  Size error in common part of parsfile structure!");

	//    
	if(!strcmp(ParsFile.CommonPars.CodeString, NORMAL_CODE_STRING))
	{
		if(ParsFile.VariationalPars.Normal.RealChannelsQuantity > MAX_ADC_CHANNEL_QUANTITY)
			AbortProgram("  RealChannelsQuantity error in variational_0 part of parsfile structure!");
		else
		{
			ChannelsQuantity = ParsFile.VariationalPars.Normal.RealChannelsQuantity;
			TotalSamplesQuantity = ParsFile.VariationalPars.Normal.RealSamplesQuantity;
			TotalKadrsQuantity = ParsFile.VariationalPars.Normal.RealKadrsQuantity;
		}
	}
	//    
	else if(!strcmp(ParsFile.CommonPars.CodeString, ADVANCED_CODE_STRING))
	{
		if(ParsFile.VariationalPars.Advanced.RealChannelsQuantity > MAX_ADC_CHANNEL_QUANTITY)
			AbortProgram("  RealChannelsQuantity error in variational_1 part of parsfile structure!");
		else
		{
			ChannelsQuantity = ParsFile.VariationalPars.Advanced.RealChannelsQuantity;
			TotalSamplesQuantity = ParsFile.VariationalPars.Advanced.RealSamplesQuantity;
			TotalKadrsQuantity = ParsFile.VariationalPars.Advanced.RealKadrsQuantity;
		}
	}

/*
  
(10*ChannelsQuantity+0x1)*KadrsQuantity-0x1
*/
	//    
	BlockKadrsQuantity = (MAX_CHAR_BUFFER_SIZE + 1.0)/(10.0*ChannelsQuantity + 1.0);
	if(BlockKadrsQuantity > TotalKadrsQuantity) BlockKadrsQuantity = TotalKadrsQuantity;
	BlockSamplesQuantity = ChannelsQuantity * BlockKadrsQuantity;
	//    
	CharBuffer = new char[(10.0*ChannelsQuantity + 1.0)*BlockKadrsQuantity - 1.0];
	if(!CharBuffer) AbortProgram("  Can not allocate memory for text buffer\n");
	//    
	DataBuffer = new SHORT[BlockSamplesQuantity];
	if(!DataBuffer) AbortProgram("  Can not allocate memory for data buffer\n");
	//    
	CurSamplesQuantity = OldCurSamplesQuantity = 0x0;

	//      
	printf(" \n");
	hConvertThread = CreateThread(0, 0x2000, ServiceConvertThread, 0, 0, &ConvertTid);
	if(!hConvertThread) AbortProgram(" ServiceConvertThread() --> Bad\n");
	else printf(" ServiceConvertThread() --> OK\n");

	//         
	printf("\n Press any key if you want to terminate this program...\n\n");
	while(!IsConvertThreadComplete)
	{
		if(CurSamplesQuantity != OldCurSamplesQuantity)
			{ printf(" Processing: %8.1f%\r", 100.0*CurSamplesQuantity/TotalSamplesQuantity); OldCurSamplesQuantity = CurSamplesQuantity; }
		else Sleep(20);
	}

	//      
	WaitForSingleObject(hConvertThread, INFINITE);

	//        
	printf("\n\n");
	if(ConvertThreadErrorNumber) { AbortProgram(NULL, false); ShowThreadErrorMessage(); }
	else AbortProgram(" The program was completed successfully!!!\n", false);

	return 0;
}

//------------------------------------------------------------------------
// ,     
//------------------------------------------------------------------------
DWORD WINAPI ServiceConvertThread(PVOID /*Context*/)
{
	DWORD i;
	DWORD CharBufferOffset, FileBytesCount, Count;
	QWORD ConvertSamplesQuantity, ConvertKadrsQuantity;
	//
	ConvertSamplesQuantity = BlockSamplesQuantity;
	CurSamplesQuantity = FileBytesCount = 0x0;
	//
	while(ConvertSamplesQuantity == BlockSamplesQuantity)
	{
		//       
		ConvertSamplesQuantity = fread(DataBuffer, sizeof(SHORT), BlockSamplesQuantity, fpSourceFile);
		//   -  
		CurSamplesQuantity += ConvertSamplesQuantity;
		//
		ConvertKadrsQuantity = ChannelsQuantity - 0x1;
		//
		if(CurSamplesQuantity < TotalSamplesQuantity)
		{
			for(i = 0x0, CharBufferOffset = 0x0; i < ConvertSamplesQuantity; i++)
			{
				if(i == ConvertKadrsQuantity)
				{
					ConvertKadrsQuantity += ChannelsQuantity;
					Count = sprintf(CharBuffer + CharBufferOffset, "%10i\n", DataBuffer[i]);
					if((int)Count == EOF) { ConvertThreadErrorNumber = 0x1; break; }
//					FileBytesCount += Count + 0x1;
				}
				else
				{
					Count = sprintf(CharBuffer + CharBufferOffset, "%10i", DataBuffer[i]);
					if((int)Count == EOF) { ConvertThreadErrorNumber = 0x1; break; }
//					FileBytesCount += Count;
				}
				CharBufferOffset += Count;
			}
		}
		else
		{
			for(i = 0x0, CharBufferOffset = 0x0; i < ConvertSamplesQuantity; i++)
			{
				if((i == ConvertKadrsQuantity) && ((i+1) < ConvertSamplesQuantity))
				{
					ConvertKadrsQuantity += ChannelsQuantity;
					Count = sprintf(CharBuffer + CharBufferOffset, "%10i\n", DataBuffer[i]);
					if((int)Count == EOF) { ConvertThreadErrorNumber = 0x1; break; }
//					FileBytesCount += Count + 0x1;
				}
				else
				{
					Count = sprintf(CharBuffer + CharBufferOffset, "%10i", DataBuffer[i]);
					if((int)Count == EOF) { ConvertThreadErrorNumber = 0x1; break; }
//					FileBytesCount += Count;
				}
				CharBufferOffset += Count;
			}
		}
		//   
		if(ConvertThreadErrorNumber) break;
		else if(kbhit()) { ConvertThreadErrorNumber = 0x2; break; }
		//       
      fwrite(CharBuffer, sizeof(BYTE), CharBufferOffset, fpTargetFile);
	}

	//  
	Sleep(100);
	//       
	IsConvertThreadComplete = true;
	//      
	return 0x0;
}

//------------------------------------------------------------------------
//   
//------------------------------------------------------------------------
void AbortProgram(char *ErrorString, bool AbortionFlag)
{
	//    
	if(DataBuffer) { delete[] DataBuffer; DataBuffer = NULL; }
	//    
	if(CharBuffer) { delete[] CharBuffer; CharBuffer = NULL; }
	//     
	if(hConvertThread) { CloseHandle(hConvertThread); hConvertThread = NULL; }

	//    
	if(fpSourceFile) fclose(fpSourceFile);
	if(fpParsFile) fclose(fpParsFile);
	if(fpTargetFile) fclose(fpTargetFile);

	//   
	if(ErrorString) printf(ErrorString);

	//   
	if(kbhit()) { while(kbhit()) getch(); }

	//   -   
	if(AbortionFlag) exit(0x1);
	//     
	else return;
}

//------------------------------------------------------------------------
//    
//------------------------------------------------------------------------
void ShowThreadErrorMessage(void)
{
	switch(ConvertThreadErrorNumber)
	{
		case 0x1:
			printf(" CONVERT Thread: Data to Text Converting --> Bad\n");
			break;

		case 0x2:
			//     ,   
			printf(" CONVERT Thread: The program was terminated!\n");
			break;
         
		default:
			printf(" Unknown error!\n");
			break;
	}

	return;
}

